//------------------------------------------------------------------------------------------------------------------------
// SEGPAL - Bibliothèque de composants XCOS pour HYDROTUR
//
// Fonction			:	SinuSync
// Auteur			:	PERRICHON Pierre
// Date				:	07/01/2021
// Version			:	1.0
//
// Sujet			: 	Fonction Sinus avec synchronisation au temps d'amorçage
//
// Paramétrage		:	Instant de départ (s)
//						ASinus
//						Période
//
// Autres données	:	
//						
//						
// Sorties			:	Sinus synchronisé
//						
//						
//						
// Interface IHM	:	SinuSync.sci
// Code objet		;	SinuSyncC.c 
//
// Programme de test:	SinuSync.zos, GeneBF.zcos, SinusAmorti.zcos, Busy.zcos
//
//------------------------------------------------------------------------------------------------------------------------

/*--------------------------------------------------------------------------*/
#include <math.h>
#include "scicos_block4.h"
#include "scicos.h"
/*--------------------------------------------------------------------------*/

void SinuSyncC(scicos_block *Cblk, scicos_flag flag)
{
	static char *Module="SinuSyncC";
	
	double *Out;
	double tSinus, ASinus, PSinus, omega,pi;
	double t;
			
	switch (flag) {
								
		case ReInitialization:
		case OutputUpdate:
		
					tSinus=Cblk->rpar[0];
					ASinus=Cblk->rpar[1];
					PSinus=Cblk->rpar[2];
					
					t = get_scicos_time();
					 
					pi=M_PI;
					omega=2.*pi/PSinus;
					
					// Evaluation de la fonction F
					//----------------------------
					Out = GetRealOutPortPtrs(Cblk,1);

					Out[0]=t<tSinus ? 0. : ASinus*sin(omega*(t-tSinus));
					
					break;											
	}
}