//------------------------------------------------------------------------------------------------------------------------
// SEGPAL - Bibliothèque de composants XCOS pour HYDROTUR
//
// Fonction			:	Step2
// Auteur			:	PERRICHON Pierre
// Date				:	14/06/2021
// Version			:	1.0
//
// Sujet			: 	Double échelon de durée programmable
//
// Paramétrage		:	Instant de départ (s)
//						Durée (s)
//						Valeur initiale à t=0
//						Amplitude
//
// Autres données	:	
//						
//						
// Sorties			:	Echelons appliqués au signal d'entrée
//						
//						
//						
// Interface IHM	:	Step2.sci
// Code objet		;	Step2C.c 
//
// Programme de test:	Step2.zos
//
//------------------------------------------------------------------------------------------------------------------------
#include <math.h>
#include "scicos_block4.h"
#include "scicos.h"

void Step2C(scicos_block *Cblk, scicos_flag flag)
{
		static char *Module="Step2C";

		double StartTime, Duree, ValIni, Echelon, ValFin, Value;
		double t;
		double *Out;
		
		StartTime=Cblk->rpar[0];
		Duree=Cblk->rpar[1];
		ValIni=Cblk->rpar[2];
		Echelon=Cblk->rpar[3];
		
		ValFin=ValIni+Echelon;
		
		switch (flag) {
		
			case ReInitialization:
			case OutputUpdate:
		
					Out = GetRealOutPortPtrs(Cblk,1);
		
					t=get_scicos_time();
					
					Value=ValIni;
					if (t>=StartTime && t <= StartTime + Duree) Value=ValFin;
					
					Out[0] = Value;
		
					break;
			
		}
		
}
/*--------------------------------------------------------------------------*/
