// This file is released under the 3-clause BSD license. See COPYING-BSD.

// This macro compiles the files

function builder_c()
    src_c_path = get_absolute_file_path("builder_c.sce");

    CFLAGS = ilib_include_flag(src_c_path);
    LDFLAGS = "";
    if (getos()<>"Windows") then
        if ~isdir(SCI+"/../../share") then
            // Source version
            CFLAGS = CFLAGS + " -I" + SCI + "/modules/scicos_blocks/includes" ;
            CFLAGS = CFLAGS + " -I" + SCI + "/modules/scicos/includes" ;
        else
            // Release version
            CFLAGS = CFLAGS + " -I" + SCI + "/../../include/scilab/scicos_blocks";
            CFLAGS = CFLAGS + " -I" + SCI + "/../../include/scilab/scicos";
        end
    else
        CFLAGS = CFLAGS + " -I" + SCI + "/modules/scicos_blocks/includes";
        CFLAGS = CFLAGS + " -I" + SCI + "/modules/scicos/includes";

        // Getting symbols
        if findmsvccompiler() <> "unknown" & haveacompiler() then
            LDFLAGS = LDFLAGS + " """ + SCI + "/bin/scicos.lib""";
            LDFLAGS = LDFLAGS + " """ + SCI + "/bin/scicos_f.lib""";
        end
    end

    tbx_build_src(["PSBC", "ExponentC", "IntLimC" , "RampeC", ...
				   "MemoC", "SaturC", "GainVarC", "Step2C",, "EdgeTriggerC", "TempoTrigC",..
				   "SinuSyncC", "DiracSyncC", "Hysteresis_HC", "Relais_HC", "Interpln_HC","IntSPEC", "GeneBFC"],..
				  ["PSBC.c", "ExponentC.c", "IntLimC.c", "RampeC.c" ..
                   "MemoC.c", "SaturC.c", "GainVarC.c", "Step2C.c", "EdgeTriggerC.c", "TempoTrigC.c",..
	               "SinuSyncC.c", "DiracSyncC.c", "Hysteresis_HC.c", "Relais_HC.c", "Interpln_HC.c", "Common.C", "IntSPEC.c", "GeneBFC.c"], ..
    "c",                                                                    ..
    src_c_path,                                                             ..
    "",                                                                     ..
    LDFLAGS,                                                                ..
    CFLAGS,                                                                 ..
    "",                                                                     ..
    "",                                                                     ..
    "xcos_tbx_skel");
endfunction

disp("...Compilateur C")
builder_c();
clear builder_c; // remove builder_c on stack
